"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Sequelize = require("sequelize");
const _1 = require(".");
const user_model_1 = require("../models/user-model");
const index_1 = require("./index");
// const uri = 'postgres://user:pass@example.com:5432/dbname'
exports.initDatabase = (dbURI = _1.DATABASE_URL) => {
    const sequelize = new Sequelize(dbURI);
    const User = user_model_1.initUserModel(sequelize, index_1.USER_MODEL_PATH);
    User.sync();
};
//# sourceMappingURL=db.js.map