"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("express-gateway");
const index_1 = require("./../config/index");
const policy = {
    name: 'auth-secure',
    policy: actionParams => {
        return (req, res, next) => {
            delete req.headers[index_1.AUTH_HEADER];
            next();
        };
    },
    schema: {
        $id: 'http://express-gateway.io/schemas/policies/auth-secure.json',
        type: 'object',
        properties: {
            test: { type: 'array' }
        }
    }
};
exports.default = policy;
//# sourceMappingURL=auth-secure-policy.js.map