import { Response } from 'express-serve-static-core';
export declare class ResponseUtil {
    static sendUnauthorized: (res: Response, message?: string) => Response;
    static sendForbidden: (res: Response) => Response;
    static sendTokenExpiredError: (res: Response) => Response;
    static sendRefreshExpiredError: (res: Response) => Response;
    static sendInvalidId: (res: Response) => Response;
    static sendValidationError: (res: Response, errors: any[]) => Response;
    static sendDuplicateKeyError: (res: Response, message: string, errors: any[]) => void;
}
