export declare const getUserView: (user: UserInstance) => IUserAttributes;
export declare const getUserViews: (users: UserInstance[]) => IUserAttributes[];
export declare const findUserByPayload: (payload: IJwtPayload) => Promise<UserInstance>;
export declare const generateAuthToken: (user: UserInstance, refreshExpiresIn?: number) => any;
export declare const hashPassword: (password: string) => Promise<string>;
export declare const comparePassword: (user: UserInstance, password: string) => Promise<boolean>;
